#include <stdio.h>

#define NONE 10000
#define ST 0
#define CY 1
#define TS 2
#define TC 3
#define VS 4
#define ALL 1024
#define NUM_S 10

void main()
	{
	int next[ALL], count[5], type[ALL];
	int s, i ,temp, set, total[5];
	FILE *fp1, *fp2;
	char name[10];

	fp1 = fopen("data", "r");
	fp2 = fopen("o", "w");

for (i=0; i<5; i++) total[i] = 0;
for (set=0; set<NUM_S; set++) {

	for (i=0; i<5; i++) count[i] = 0;
	for (s=0; s<ALL; s++) type[s] = NONE;


	for (s=0; s<ALL; s++) {
		fscanf(fp1, "%d", &(next[s]));
		if (s==next[s]) type[s] = ST;
		}


	for (s=0; s<ALL; s++) {
		if (type[s]==NONE) {
			temp = s;
			while (type[temp]==NONE) {
				type[temp] = VS;
				temp = next[temp];
				}
			if (type[temp]==ST) {				// ST is stable state
				temp = s;
				while (type[temp]==VS) {
					type[temp] = TS;
					temp = next[temp];
					}
				}
			else if (type[temp]==TS) {			// TS is on the way to stable state
				temp = s;
				while (type[temp]==VS) {
					type[temp] = TS;
					temp = next[temp];
					}
				}
			else if (type[temp]==VS) {			// a new cycle
				count[1]++;;
				while (type[temp]==VS) {
					type[temp] = CY;
					temp = next[temp];
					}
				temp = s;
				while (type[temp]==VS) {
					type[temp] = TC;
					temp = next[temp];
					}
				}
			else if (type[temp]==CY) {			// CY is cycle
				temp = s;
				while (type[temp]==VS) {
					type[temp] = TC;
					temp = next[temp];
					}
				}
			else if (type[temp]==TC) {		// TC is on the way to cycle
				temp = s;
				while (type[temp]==VS) {
					type[temp] = TC;
					temp = next[temp];
					}
				}
			}
		}

	for (s=0; s<ALL; s++)
		if (type[s]==ST) count[0]++;
		else if (type[s]==CY) count[2]++;
		else if (type[s]==TS) count[3]++;
		else if (type[s]==TC) count[4]++;

	fprintf(fp2, "stable states: %d\n", count[0]);
	fprintf(fp2, "cycles       : %d\n", count[1]);
	fprintf(fp2, "in cycles    : %d\n", count[2]);
	fprintf(fp2, "to stable    : %d\n", count[3]);
	fprintf(fp2, "to cycle     : %d\n\n", count[4]);

total[0] += count[0];
total[1] += count[1];
total[2] += count[2];
total[3] += count[3];
total[4] += count[4];
}
fprintf(fp2, "stable states: %d\n", total[0]);
fprintf(fp2, "cycles       : %d\n", total[1]);
fprintf(fp2, "in cycles    : %d\n", total[2]);
fprintf(fp2, "to stable    : %d\n", total[3]);
fprintf(fp2, "to cycle     : %d\n\n", total[4]);

	fclose(fp1);
	fclose(fp2);

	}
